//------------------------------------------------------------------
#property link      "www.forex-tsd.com"
#property copyright "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1  LimeGreen
#property indicator_color2  PaleVioletRed
#property indicator_color3  DarkGray
#property indicator_style3  STYLE_DOT

//
//
//
//
//

extern int    MaPeriod      = 20;
extern int    MaMethod      = MODE_SMA;
extern int    PriceToUse    = PRICE_TYPICAL;
extern int    AtrPeriod     = 50;
extern double AtrMultiplier = 2.5;
extern int    MaAtrShift    = 1;
extern string MaMethods     = "";
extern string _0            = "0 - SMA";
extern string _1            = "1 - EMA";
extern string _2            = "2 - SMMA";
extern string _3            = "3 - LWMA";

double bup[];
double bdn[];
double ma[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,bup);
   SetIndexBuffer(1,bdn);
   SetIndexBuffer(2,ma);
      IndicatorShortName("Keltner channel ("+MaPeriod+","+DoubleToStr(AtrMultiplier,1)+")");
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int count,counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

      for(int i = limit; i >= 0; i--)
      {
         double atr = iATR(NULL,0,AtrPeriod,i+MaAtrShift);
            ma[i]  = iMA(NULL,0,MaPeriod,0,MaMethod,PriceToUse,i+MaAtrShift);
            bup[i] =  ma[i]+AtrMultiplier*atr;
            bdn[i] =  ma[i]-AtrMultiplier*atr;
      }
   return(0);
}